#include "stdafx.h"
#include "Extensions.h"
#include "ScriptManager.h"

void CScript::FinalRelease()
{
	script_node_->Active(false);
}

void CScript::Attach(ScriptManager* script_manager, ScriptNode* script_node)
{
	script_manager_ = script_manager;
	script_node_ = script_node;
	script_node_->Active(true);
}

HRESULT __stdcall CScript::Evaluate(VARIANT DefaultValue, VARIANT *pResult)
{
	return script_manager_->EvaluateScript(script_node_, *pResult, &DefaultValue);
}

void CExtensions::Attach(ScriptManager* script_manager)
{
	script_manager_ = script_manager;
}

HRESULT __stdcall CExtensions::LoadScript(BSTR ScriptName, Script **pResult)
{
	// load the script, a syntax error will return a failed hr
	ScriptNode* script_node = 0;
	HRESULT hr = script_manager_->LoadScript(ScriptName, script_node);
	if (FAILED(hr))
		return hr;

	CComObject<CScript>* script = 0;
	hr = CComObject<CScript>::CreateInstance(&script);
	if (FAILED(hr))
		return hr;

	hr = script->QueryInterface(IID_Script, (void**)pResult);
	if (FAILED(hr))
		return hr;

	script->Attach(script_manager_, script_node);
	return S_OK;
}
