#pragma once
#include "ScriptCaching-Com.h"

class ScriptNode;

class ATL_NO_VTABLE ScriptManager;

class ATL_NO_VTABLE CScript : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public ISupportErrorInfoImpl<&IID_Script>,
	public IDispatchImpl<Script, &IID_Script, &LIBID_ScriptCaching_ComLib, 0xffff, 0xffff>
{
	ScriptManager* script_manager_;
	ScriptNode* script_node_;

public:
	CScript() : script_manager_(0), script_node_(0) { }
	~CScript() { }

public:
	HRESULT FinalConstruct() { return S_OK; }
	void FinalRelease();

	void Attach(ScriptManager* script_manager, ScriptNode* script_node);

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	BEGIN_COM_MAP(CScript)
		COM_INTERFACE_ENTRY(ISupportErrorInfo)
		COM_INTERFACE_ENTRY(Script)
		COM_INTERFACE_ENTRY(IDispatch)
	END_COM_MAP()

public:
    virtual HRESULT __stdcall Evaluate(VARIANT DefaultValue, VARIANT *pResult) override;
};

class ATL_NO_VTABLE CExtensions : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public ISupportErrorInfoImpl<&IID_Extensions>,
	public IDispatchImpl<Extensions, &IID_Extensions, &LIBID_ScriptCaching_ComLib, 0xffff, 0xffff>
{
	ScriptManager* script_manager_;

public:
	CExtensions() : script_manager_(0) { }
	~CExtensions() { }

public:
	HRESULT FinalConstruct() { return S_OK; }
	void FinalRelease() { }

	void Attach(ScriptManager* script_manager);

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	BEGIN_COM_MAP(CExtensions)
		COM_INTERFACE_ENTRY(ISupportErrorInfo)
		COM_INTERFACE_ENTRY(Extensions)
		COM_INTERFACE_ENTRY(IDispatch)
	END_COM_MAP()

public:
    virtual HRESULT __stdcall LoadScript(BSTR ScriptName, Script **pResult) override;
};
